#!/bin/bash
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# upgrade_zephir.sh
#
# script de mise à jour de la base de données zephir
#
###########################################################################
PG_CONF_DIR=/etc/postgresql/8.3/main
PG_CONF_FILE=$PG_CONF_DIR/pg_hba.conf
PG_SERVICE=postgresql-8.3
MAJ_MD5_FILE=/usr/share/zephir/sql/sql_maj.md5

# 1. se mettre en mode sans mot de passe
mv -f $PG_CONF_FILE $PG_CONF_FILE.savezephir
echo -e "local\tall\tall\ttrust" > $PG_CONF_FILE
chown postgres.postgres $PG_CONF_FILE
chmod 600 $PG_CONF_FILE
/etc/init.d/$PG_SERVICE stop
/etc/init.d/$PG_SERVICE start
sleep 1
echo " * Regénération des mots de passe"
# on regénère le mot de passe
/usr/share/eole/gen_pwd.py >/dev/null 2>&1
# mise à jour de la base si le fichier maj.sql a changé
LanceMaj="oui"
if [ -f $MAJ_MD5_FILE ]
then
	/usr/bin/md5sum -c $MAJ_MD5_FILE >/dev/null 2>&1
	[ $? -eq 0 ] && LanceMaj="non"
fi
if [ "$LanceMaj" == "oui" ]
then
	# on met à jour le schéma de la base
	echo " * Mise à jour de la base de données"
	su postgres <<EOF
psql -d zephir -Uzephir -f /usr/share/zephir/sql/maj.sql >/dev/null 2>&1
EOF
	/usr/bin/md5sum /usr/share/zephir/sql/maj.sql > $MAJ_MD5_FILE
	sleep 1
fi
# 5. se remettre en mode mot de passe
rm -f $PG_CONF_FILE
mv -f $PG_CONF_FILE.savezephir $PG_CONF_FILE
chown postgres.postgres $PG_CONF_FILE
chmod 600 $PG_CONF_FILE
